CreateDockWnd			PROTO :DWORD,:HWND,:HINSTANCE,:DWORD
GetRectClient			PROTO :DWORD

.const
WS_DOCK_RESIZE			equ	0010h	;allow resize when docked
WS_FLOAT_RESIZE			equ	0020h	;allow resize when floating
WS_HIDE					equ	0040h	;hides the dock-window instead of destroying it
WS_ALIGN_LEFT			equ	0080h	;allow window docked left
WS_ALIGN_RIGHT			equ	0100h	;allow window docked right
WS_ALIGN_TOP			equ	0200h	;allow window docked top
WS_ALIGN_BOTTOM			equ	0400h	;allow window docked bottom
WS_ALIGN_ANY			equ 0780h	;allow window docked any

WP_DOCK_LEFT			equ	1	;window docked left
WP_DOCK_TOP				equ	2	;window docked top
WP_DOCK_RIGHT			equ	3	;window docked right
WP_DOCK_BOTTOM			equ	4	;window docked bottom

.data?
	
DOCKWND				struct
	dwStyle			DWORD ?		;styles
	fDocked			BOOL  ?		;docked/floating?
	fButtonClose	BOOL  ?		;has button close when is docked
	xFloat			DWORD ?		;x position of frame when is floating in screen coordinates
	yFloat			DWORD ?		;y position of frame when is floating in screen coordinates
	cxFloat			DWORD ?		;width of client when is floating 
	cyFloat			DWORD ?		;height of client when is floating
	nDockSize		DWORD ?		;width or height of frame when is docked
	nDockPos		DWORD ?		;position of frame when is docked
	hwndChild		HWND ?		;handle to the child window to host in frame
	hwnd			HWND ?		;handle to frame
DOCKWND				ends

