.486
.model flat,stdcall
option casemap:none

include DockingTest.inc

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax
	
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	;=============================================
	; Register the frame window class
	;=============================================
	mov   wc.cbSize,sizeof WNDCLASSEX
	mov   wc.style,CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, offset WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE+1
	mov   wc.lpszMenuName,IDR_MENU
	mov   wc.lpszClassName,offset szMDIFrameName
	invoke LoadIcon,hInst,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	
	invoke CreateWindowEx,NULL,addr szMDIFrameName,addr szAppName,\
           WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,0,\
           hInst,NULL
	mov   hwndFrame,eax
	invoke ShowWindow, hwndFrame,SW_MAXIMIZE
	invoke UpdateWindow, hwndFrame
	.while TRUE
		invoke GetMessage, addr msg,NULL,0,0
		.break .if (!eax)
		invoke TranslateMDISysAccel,hwndClient,addr msg
		.if eax==0
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.endw
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
LOCAL ClientStruct:CLIENTCREATESTRUCT
LOCAL hdc:HDC
LOCAL rcClFrame:RECT
LOCAL dwSize:DWORD

	.if uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_CREATE
		mov ClientStruct.hWindowMenu,NULL
		mov ClientStruct.idFirstChild,NULL
		invoke CreateWindowEx,NULL,addr szMDIClientName,NULL,\
	           	WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,CW_USEDEFAULT,\
	           	CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,\
	           	hInstance,addr ClientStruct
		mov hwndClient,eax
	    
		mov Docker.fDocked,TRUE
		mov Docker.fButtonClose,TRUE
		mov Docker.cxFloat,200
		mov Docker.cyFloat,60
		mov Docker.xFloat,0
		mov Docker.yFloat,0
		mov Docker.nDockSize,120
		mov Docker.nDockPos,WP_DOCK_LEFT
		mov Docker.hwndChild,NULL
		mov Docker.dwStyle,(WS_HIDE or WS_DOCK_RESIZE)
		invoke CreateDockWnd,addr Docker,hWnd,hInstance,CTEXT("Test")
		
	.elseif uMsg==WM_SIZE
		.if hwndClient != NULL
			invoke GetRectClient,addr rcClFrame
			mov ecx,rcClFrame.right
			sub ecx,rcClFrame.left		;ecx=width
			mov edx,rcClFrame.bottom
			sub edx,rcClFrame.top		;edx=height
			invoke MoveWindow,hwndClient,rcClFrame.left,rcClFrame.top,ecx,edx,TRUE
		.endif	
	.elseif uMsg==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if ax==IDM_EXIT
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.else
			invoke DefFrameProc,hWnd,hwndClient,uMsg,wParam,lParam	
			ret
		.endif
	.else
		invoke DefFrameProc,hWnd,hwndClient,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

end start

